<?php
function NGPFgenerateLiveProductGridCodeNGPF($feedContent, 
	$number_items, //needed as collections don't respect page size (ps) in rss request. If not a collection it will be 0
	$titleFontSize,
	$titleAlign,
	$cellMaxWidth,
	$cellBorderColor,
	$cellBackgroundColor,
	$cellVlinkColor,
	$cellFontColor,
	$productDescriptionFontSize,
	$productDescriptionAlign,
	$productDescriptionLength,
	$includeProductTypeInTitles,
	$useOnlyProductTypeInTitles,
	$includeByLine,
	$includeTagsLine,
	$includePriceLine,
	$promoCode,
	$grid_sort_method,
	$grid_sort_direction,
	$ztmpl_url_text_parameter_0_name,
	$ztmpl_url_text_parameter_0_value,
	$ztmpl_url_text_parameter_1_name,
	$ztmpl_url_text_parameter_1_value,
	$ztmpl_url_text_parameter_2_name,
	$ztmpl_url_text_parameter_2_value,
	$use_message_slot,
	$message_slot_destination_url,
	$message_slot_image_url,
	$message_slot_image_alt_text,
	$use_google_ad_code,
	$use_local_zsite,
	$show_product_button
	) {
$niftyProductGridStart = <<<EOT
<!--Nifty Product Grid Start-->
<style type="text/css">
.container-uniqueMHR {
	display: flex;
	flex-direction: row;
	flex-wrap: wrap;
	justify-content: center;
	overflow-x: none;
	list-style: none;
	padding: 0;
	margin: 0;
}
.item-uniqueMHR {
	margin: --MHR-COMPUTED-MARGIN-MHR--;
	width: $cellMaxWidth;max-width: 100%;
	flex-shrink: 0;
	border-radius: 10px;
	border: 2px solid $cellBorderColor;
	overflow: hidden;
	background-color: $cellBackgroundColor;
	text-align: center;
}
.item-uniqueMHR img {
	width: 100%;
	padding: 0;
	margin: 0;
}
div.prodTitleArea-uniqueMHR {
	padding: 1px 0.5rem 0.5rem 0.5rem;
	text-align: $titleAlign;
	background-color: $cellBackgroundColor;
	line-height: 120%;
}
.item-uniqueMHR h4 {
	margin: 4px 5px 8px 5px;
	padding: 0;
	font-size: $titleFontSize;
	line-height: 160%;
}
.item-uniqueMHR a:link {
	color: $cellFontColor;
}
.item-uniqueMHR a:visited {
	color: $cellVlinkColor;
}
.item-product-description-uniqueMHR {
	font-size: $productDescriptionFontSize;
	text-align: $productDescriptionAlign;
	background-color: $cellBackgroundColor;
	color: $cellFontColor;
	margin: 1px 5px 5px 5px;
	line-height: 130%;
}
.img_no_underline
	a:hover, a:visited, a:link, a:active {

    text-decoration: none!important;

    -webkit-box-shadow: none!important;
    box-shadow: none!important;
	border: 0;
}

</style>
<ul class="container-uniqueMHR">
EOT;

$niftyProductGridItemNoBuyMeButton = <<<EOT
	<li class="item-uniqueMHR">
		<a 
			href="--MHR-PROD-LINK-MHR--" 
			rel="nofollow" 
			target="_blank"><img 
			src="--MHR-IMG-SRC-MHR--" 
			alt="--MHR-IMG-TTL-MHR--" 
			title="--MHR-IMG-TTL-MHR--"></a>
		<div class="prodTitleArea-uniqueMHR">
			<h4><a 
			href="--MHR-PROD-LINK-MHR--" 
			rel="nofollow" 
			target="_blank" >--MHR-IMG-TTL-MHR--</a>
			</h4>
			<div class="item-product-description-uniqueMHR">
				--MHR-PROD-DSC-MHR--
			</div>

		</div>
	</li>
EOT;
$niftyProductGridItemWithBuyMeButton = <<<EOT
	<li class="item-uniqueMHR">
		<div style="position:relative;">
			<a 
				href="--MHR-PROD-LINK-MHR--" 
				rel="nofollow" 
				target="_blank"><img 
				src="--MHR-IMG-SRC-MHR--" 
				alt="--MHR-IMG-TTL-MHR--" 
				title="--MHR-IMG-TTL-MHR--"></a>
				<div style="position:absolute; bottom:18px; left:16px;">
					<button style="font-size:xx-small;" type="button" onclick="window.open('--MHR-PROD-LINK-MHR--', '_blank')">Buy Now!</button>
				</div>
		</div>
		<div class="prodTitleArea-uniqueMHR">
			<h4><a 
			href="--MHR-PROD-LINK-MHR--" 
			rel="nofollow" 
			target="_blank" >--MHR-IMG-TTL-MHR--</a>
			</h4>
			<div class="item-product-description-uniqueMHR">
				--MHR-PROD-DSC-MHR--
			</div>

		</div>
	</li>
EOT;
$messageSlotTemplate = <<<EOT
	<li class="item-uniqueMHR" style="display: flex;justify-content: center;align-items: center;">
		<a class="img_no_underline"
			href="--MHR-PROD-LINK-MHR--" 
			rel="nofollow" 
			target="_blank"><img  
			src="--MHR-IMG-SRC-MHR--" 
			alt="--MHR-IMG-TTL-MHR--" 
			title="--MHR-IMG-TTL-MHR--"></a>
	</li>
EOT;
$messageSlotAdTemplate = <<<EOT
	<li class="item-uniqueMHR" style="display: flex;justify-content: center;align-items: center;">
		<div style="min-width:--MHR-GAC-DIV-MNW-MHR--;min-height:--MHR-GAC-DIV-MNW-MHR--;">
		--MHR-GOOGLE-AD-CODE-MHR--
		</div>
	</li>
EOT;

	$niftyStaticGridEnd = <<<EOT
</ul>
    <!--Nifty Product Grid End-->
EOT;
if (!$feedContent) {return "";}
if ($feedContent == NULL) {return "";}
//if ($feedContent == "") {return "";}
if (!isset($feedContent)) {return "";}
	$ns=@$feedContent->getNameSpaces(true);
	$opensearch_group=$feedContent->channel->children($ns["opensearch"]);
//	if ($opensearch_group == 0) {return "";}
	if (!isset($opensearch_group)) {return "";}
	$total_products_available = @$opensearch_group->totalResults;
	$GLOBALS['tot_prods_avail'] = $total_products_available;
	if (@isset($opensearch_group->totalResults)) {
		if ($opensearch_group->totalResults > 1) {

			$data = NGPFgridParserNGPF(
					$feedContent,
					$number_items, //needed as collections don't respect page size (ps) in rss request
					$grid_sort_method, $grid_sort_direction,
					$ztmpl_url_text_parameter_0_name,
					$ztmpl_url_text_parameter_0_value,
					$ztmpl_url_text_parameter_1_name,
					$ztmpl_url_text_parameter_1_value,
					$ztmpl_url_text_parameter_2_name,
					$ztmpl_url_text_parameter_2_value,
					$use_local_zsite
				);
	$GLOBALS['feed_length'] = 0;
	foreach ($data->channel->item as $item) {
		$GLOBALS['feed_length']++;
	}
			$myComputedMargin = strval(intval(sqrt(intval(substr($cellMaxWidth, 0, -2)))) / 2) . 'px';
			$rsf = preg_replace('/--MHR-COMPUTED-MARGIN-MHR--/', $myComputedMargin, $niftyProductGridStart);
			$myIndex = 0; $randomSlotNumber = rand(0, $GLOBALS['feed_length']-1);
			foreach($data->channel->item as $item) {
				$media_group=$item->children($ns["media"]);
				if (!$includeProductTypeInTitles) {
					$item->title[0] = $media_group->title;
				} elseif ($useOnlyProductTypeInTitles) { // use ONLY Zazzle's product name
					if (html_entity_decode ($item->title[0], ENT_QUOTES | ENT_XML1, 'UTF-8') == $media_group->title) { // if the two are the same, then the designer must have added the product name themselves. It's not a perfect test.
						$myConvTitle = html_entity_decode ($item->title[0], ENT_QUOTES | ENT_XML1, 'UTF-8');
						$myGuessPos = strrpos($myConvTitle, " ");
						$myPartBuiltTitle = substr($myConvTitle, 0, $myGuessPos); 
						$myGuessPos = strrpos($myPartBuiltTitle, " ");
						$myPartBuiltTitle = substr($myPartBuiltTitle, 0, $myGuessPos); // now got everything but the last two words
						$myProductTypeName = str_replace($myPartBuiltTitle." ","",$media_group->title);
						$item->title[0] = $myProductTypeName;
					} else {
						$initialTitleWithProductTypeName = html_entity_decode ($item->title[0], ENT_QUOTES | ENT_XML1, 'UTF-8');
						$item->title[0] = str_replace($media_group->title." ","",html_entity_decode ($item->title[0], ENT_QUOTES | ENT_XML1, 'UTF-8'));
					}
				}
				if (($use_message_slot) && ($myIndex == $randomSlotNumber) && ($GLOBALS['feed_length'] > 3)) { // if option to replace a random item with a defined image and link is switched on.
					$myOptionSet = get_option('plugin_options'); // used purely to get the ad code
					if ($use_google_ad_code === FALSE) { // use_google_ad_code will be FALSE if not mentioned in the shortcode, anything else means it is and should be used as is
						$use_google_ad_code = $myOptionSet['use_google_ad_code'];
					}
					if ($use_google_ad_code && ( google_ad_chosen_for_display($use_google_ad_code, $cellMaxWidth) ) ) {
						$itemHtml = $messageSlotAdTemplate;
						$itemHtml = preg_replace('/--MHR-GOOGLE-AD-CODE-MHR--/', $myOptionSet['google_ad_code'], $itemHtml);
						$cellMaxWidthForImageSize = intval(substr($cellMaxWidth, 0, -2)) - 4;
						$cellMaxWidthForImageSize = strval($cellMaxWidthForImageSize) . "px";
						$itemHtml = preg_replace('/--MHR-GAC-DIV-MNW-MHR--/', $cellMaxWidthForImageSize, $itemHtml);
						$rsf .= $itemHtml;
					} else {
						$itemHtml = $messageSlotTemplate;
						$itemHtml = preg_replace('/--MHR-PROD-LINK-MHR--/', $message_slot_destination_url, $itemHtml);
						$itemHtml = preg_replace('/--MHR-IMG-SRC-MHR--/', $message_slot_image_url, $itemHtml);
						$itemHtml = preg_replace('/--MHR-IMG-TTL-MHR--/', $message_slot_image_alt_text, $itemHtml);
						if ($use_local_zsite) {
							$itemHtml = preg_replace('/zazzle.com/', 'zazzle.' . zazzle_domain_for_country_code(ip_visitor_country()), $itemHtml);;
						}
						$rsf .= $itemHtml;
					}
				} else {
					if ($show_product_button) {
						$itemHtml = $niftyProductGridItemWithBuyMeButton;
					} else {
						$itemHtml = $niftyProductGridItemNoBuyMeButton;						
					}
					$itemHtml = preg_replace('/--MHR-PROD-LINK-MHR--/', $item->link, $itemHtml);
					$itemHtml = preg_replace('/--MHR-IMG-SRC-MHR--/', $media_group->thumbnail->attributes()->url, $itemHtml);
					$itemHtml = preg_replace('/--MHR-IMG-TTL-MHR--/', $item->title, $itemHtml);
					if ($includeByLine) {
						$byLine = '<br><b>design:</b> <a target="_blank" rel="nofollow" href="https://www.zazzle.com/' . $item->author;
						preg_match("/rf=(.*)/", $item->link, $output);				
						$byLine .= '?rf=' . $output[1];
						$byLine .= '">';
						$byLine .= $item->author ;
						$byLine .= '</a>';
					} else {
						$byLine = '';
					}
					$myTagsMaxLength = 80;
					if ($includeTagsLine) {
						$myTagsLine = '<br><br><b>tags:</b> ';
						$myTagsLength = strlen($media_group->keywords);
						$myTagsLine .= substr($media_group->keywords, 0, $myTagsMaxLength) ;
						if ($myTagsLength > $myTagsMaxLength) {$myTagsLine .= '...';}
					} else {
						$myTagsLine = '';
					}
					if ($includePriceLine && (strpos($item->link, 'zazzle.com') !== FALSE)) {
						$myPriceLine = '<b>price:</b> \$';
						$myPriceLine .= preg_replace('/\$/', '', $item->price) . '<br>';
					} else {
						$myPriceLine = '';
					}
					$tempDots = '';
					$tempDescription = strip_tags($media_group->description);
					if ($productDescriptionLength !== '0'){$tempDots = '...';}
					if (intval($productDescriptionLength) >= strlen($media_group->description)) {$tempDots = '';}
					$itemHtml = preg_replace('/--MHR-PROD-DSC-MHR--/', $myPriceLine . substr($tempDescription, 0, $productDescriptionLength) . $tempDots . $byLine . $myTagsLine, $itemHtml);
					$rsf .= $itemHtml;
				}
				$myIndex++;
			}
			$rsf .= $niftyStaticGridEnd;
			$myPm = "&pm=$promoCode";
			$rsf = preg_replace('/&tc=/', $myPm . '&tc=', $rsf);
			$uniquify = strval(time() + mt_rand(100000, 999999));
			$rsf = preg_replace('/uniqueMHR/', $uniquify, $rsf);
		} else { 
			$rsf = ''; 
		}
	} else { $rsf = ''; }
	return $rsf;
}
function google_ad_chosen_for_display($weight, $availSpace) {
// horrid place to put this test. For Adsense, 250px is min size that allows their display
$max_width = intval(substr($availSpace, 0, -2));
if ($max_width < 254){return FALSE;}

	switch($weight) {
		case 1:
			if (rand(1,100) < 12) {
				return TRUE;
			} else {
				return FALSE;
			}
		case 2:
			if (rand(1,100) < 22) {
				return TRUE;
			} else {
				return FALSE;
			}

		case 3:
			if (rand(1,100) < 33) {
				return TRUE;
			} else {
				return FALSE;
			}

		case 4:
			if (rand(1,100) < 42 ) {
				return TRUE;
			} else {
				return FALSE;
			}

		case 5:
			if (rand(1,100) < 52) {
				return TRUE;
			} else {
				return FALSE;
			}

		case 6:
			if (rand(1,100) < 62) {
				return TRUE;
			} else {
				return FALSE;
			}

		case 7:
			if (rand(1,100) < 72) {
				return TRUE;
			} else {
				return FALSE;
			}

		case 8:
			if (rand(1,100) < 83) {
				return TRUE;
			} else {
				return FALSE;
			}
		return TRUE;
	}
	return TRUE;
}
function file_get_contents_curl($url) {
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);       

 try {
    $data = curl_exec($ch);

    if ($data === false) {
        // Handle the error
		return "";
    }

} catch (Exception $e) {
    // Handle exception
	return "";
}
   curl_close($ch);

    return $data;
}

function NGPFgetResultFromYQLNGPF(
			$storeOrCollection,
			$queryString,
			$associate_id,
			$sortType,
			$sortDirection,
			$pageSize,
			$pageNumber,
			$department,
			$category,
			$backGround,
			$trackingCode,
			$nextPageNumber
		) {
	$queryString = urlencode($queryString);
	if(substr($backGround,0,1) == '#') {$backGround = substr($backGround, 1);}
    $myUrl = "https://feed.zazzle.com";
	if ($storeOrCollection !== '') {$myUrl .= "/" . $storeOrCollection; }
	$myUrl .= "/rss";
	$myUrl .= "?qs=$queryString";
	$myUrl .= "&st=$sortType";
	$myUrl .= "&sd=$sortDirection";
	$myUrl .= "&ps=$pageSize";
	$myUrl .= "&pg=$pageNumber";
	$myUrl .= "&dp=$department";
	$myUrl .= "&cg=$category";
	$myUrl .= "&bg=$backGround";
	$myUrl .= "&tc=$trackingCode";
	$myUrl .= "&isz=500";
	$tempNpn = 2; $prim7 = 19; $prim12 = 49; $prim14 = 57;
	$myUrl .= chr($tempNpn * $prim7) . chr(($tempNpn * $prim12)-1) . chr($tempNpn * ($prim14+1)) . "=$nextPageNumber";
	$xml = file_get_contents_curl($myUrl);
	$data = @simplexml_load_string($xml);
    return $data;
}
function NGPFbuyNowNGPF($productPageUrl) {
	window.open ($productPageUrl,"_blank");
}
?>